/////////////////////////
//  File is: BillCampbell.cpp
/////////////////////////


#include <stdio.h>
#include <stdlib.h>	// For: system()
#include <string.h>

#include "HTBasicStrings.h"

#define STRING_SIZE_CHARS (2)


//////////////////////   USE FOR TESTING NEW STUFF ////////////////////////////////////
// Passing HTBasic Strings to DLL functions:
//    If ArrayName[10] is declared, HTBasic will make it 12. The two extra bytes are the number
//       of characters in the string. In a receiving function, add TWO characters to the size you declared.
//
//    The String structure is: sssNNNSS, where sss is the actual data, NNN are terminating NULLS and unused
//       characters, and the SS are two bytes containing the number of data characters in the string.
//     The string is NULL terminated.
//
//    Example: String array declared as ArrayName[10] could contain the following:
//			H e l l o NULL NULL NULL NULL NULL 5 0      = 12 characters, not 10 as declared
//    Don't use a data structure, because it is unknown what type of data structure an HTBasic string is defined as.
//    Use: #define STRING_SIZE_CHARS (2)
//
//////////////////////////////////////////////////////////////////////////////////////
void Testallargtypes(char   strInput[][60 + STRING_SIZE_CHARS],		// this is correct format for  1d array of strings 	
                     char   strInput2[][4][60 + STRING_SIZE_CHARS],	// this is correct format for  2d array of strings 
					 char   strOutput2[][4][60 + 2])
{
int i;
int j;

	////////////// PROCESS OUTPUT PARAMETERS ////////////////////////////////

	// return 2d strings 
	for (i = 0; i <= 1; i++)   // print 8 lines 
	{
		for(j = 0; j <= 3;j++ )
		{
		    strcpy(strOutput2[i][j], strInput2[i][j]);
		
		}	// j for loop

	}	// i for loop


	strcpy(strOutput2[0][2] , "This is the returned string array....");

	// make sure the strings are ready to be passed back to HTBasic
	for(i = 0; i <= 1; i++)
	{
		for(j = 0; j <= 3; j++)
		{
			ValidateStringForHTBasic(strOutput2[i][j]);

		}	// j for loop

	}	// i for loop

}	// Testallargtypes

